<!DOCTYPE html>
<html lang="fr">
<head>
    <script src="konva.min.js"></script>
    <!--<script src="https://unpkg.com/konva@4.0.18/konva.min.js"></script>-->
    <meta charset="UTF-8">
    <title>Play with cards!</title>
    <link href="play-cards.css" rel="stylesheet" type="text/css">
</head>
<body>
    <div id="playground">
        <div id="cards">
        </div>
        <div id="runner">
        </div>
    </div>

    <script type="text/javascript">
        // horizontal scroll bar is removed by default
        document.body.classList.add("notscrollable-x");
        // and reenabled if window is resized
        window.onresize = function() {
            if (window.innerWidth == windowInnerWidth) {
                document.body.classList.add("notscrollable-x");
                document.body.classList.remove("scrollable-x");
            } else {
                document.body.classList.add("scrollable-x");
                document.body.classList.remove("notscrollable-x");
            }
        }

        const numberOfCards = 12; // adapt to number of cards from cards directory you want to display

        const windowInnerWidth = window.innerWidth;
        const windowInnerHeight = window.innerHeight;

        const ratio = 4.0; // image ratio; adapt to cards images size
        const playgroundWidth = windowInnerWidth - 12; // we leave space for potential vertical scroll bar
        const sliderWidth = 24;
        const cardsWidth = playgroundWidth - sliderWidth;

        buildPlayground(); // displaying cards

        const popperWidth = cardsWidth; // sandbox container width is set equals to cards container width; could be otherwise

        buildSandbox(); // setting the "sandbox", mostly hidden at start and which pops-in with a click on its visible part

        // sandbox uses konva.js library to allow interacting with cards
        var stage = new Konva.Stage({
            container: 'sandbox',
            width: cardsWidth,
            height: windowInnerHeight,
        });
        
        function buildPlayground() {
            let playground = document.getElementById("playground");
            playground.style.width = playgroundWidth + 'px';
            let cards = document.getElementById("cards");
            cards.style.width = cardsWidth + 'px';
            loadCards();
        }

        // displaying cards in a breakable line
        function loadCards() {
            var cards = document.getElementById('cards');
            for (i = 0; i < numberOfCards; i++) {
                var img = document.createElement("img");
                img.id = i;
                img.src = 'cards/back-' + i + '.png'; // cards are on their back at start
                img.setAttribute('onclick', 'flip(' + i + ')'); // click to flip card 
                
                // cards can be reordered by drag and drop
                img.setAttribute('draggable', 'true');
                img.setAttribute('ondragstart', 'dragstartCard(event)');
                img.setAttribute('ondragover', 'dragover(event)');
                img.setAttribute('ondrop', 'dropCard(event)');
                
                img.onload = function() {
                    var w = this.naturalWidth;
                    var h = this.naturalHeight;
                    if (w > 1) { // to exclude transparent cards image that is 1px x 1px [onload function is called when img.src changes]
                        this.width = w / ratio;
                        this.height = h / ratio;
                    }
                }
                cards.appendChild(img);
            }
        }

        function flip(i) {
            var img = document.getElementById(i);
            // first click -> card is turned over, from back to front
            // another click -> card is removed from playground [actually replaced by a bordered transparent image]
            // another click -> card reappears on its back
            if (img.src.endsWith('cards/back-' + i + '.png')) {
                img.src = 'cards/front-' + i + '.png';
            } else if (img.src.endsWith('cards/front-' + i + '.png')) {
                img.src = 'cards/transparent_px.png';
                img.classList.add("border");
            } else {
                img.classList.remove("border");
                img.src = 'cards/back-' + i + '.png';
            }
        }

        function dragstartCard(ev) {
            if (ev.target.src.endsWith('cards/transparent_px.png')) {
                ev.dataTransfer.setData("text/plain", ev.target.id + "_transparent_px"); // to deal with transparent card dragged onto slider
            } else {
                ev.dataTransfer.setData("text/plain", ev.target.id);
            }
        }

        function dragover(ev) {
            ev.preventDefault();
        }

        function dropCard(ev) {
            ev.preventDefault();
            var target = ev.target; // card the dragged card is dropped on

            // retrieving dragged card element from dragstart data
            var draggedCardData = ev.dataTransfer.getData("text/plain");
            var draggedCardId;
            if (draggedCardData.endsWith("_transparent_px")) { // dealing with transparent card specific processing
                draggedCardId = draggedCardData.replace("_transparent_px", "");
            } else {
                draggedCardId = draggedCardData;
            }
            var draggedCard = document.getElementById(draggedCardId);

            // if we drag card on another card that is on the left (or upper), it goes before it, otherwise it goes after it
            if (isAfter(draggedCard, target)) {
                target.after(draggedCard);
            } else {
                target.before(draggedCard);
            }
        }

        // a and b being two direct children of a same element, is b after a in the DOM tree?
        function isAfter(a, b) {
            var next = a.nextSibling;
            if (next == null) {
                return false;
            }
            if (next.id == b.id) {
                return true;
            } 
            return isAfter(next, b);
        }

        function buildSandbox() {
            let popper = document.createElement("div");
            popper.id = "popper";
            popper.style.width = popperWidth + 'px';
            popper.style.height = windowInnerHeight + 'px';
            const mr = popperWidth - sliderWidth;
            popper.style.marginRight = '-' + mr + 'px';
            let slider = document.createElement("div");
            slider.id = "slider";
            slider.style.width = sliderWidth + 'px';
            slider.style.height = windowInnerHeight + 'px';
            slider.onclick = function() { // click on slider -> sandbox pops in or out
                if (popper.classList.contains("popped")) {
                    popper.classList.remove("popped");
                    popper.style.marginRight = '-' + mr + 'px';
                } else {
                    popper.classList.add("popped");
                    popper.style.marginRight = 0;
                }
            }
            slider.classList.add("inactive");

            // drag and drop a card on the slider and a copy of the card will be added to the sandbox
            slider.setAttribute('ondragenter', 'dragenterSlider(event)');
            slider.setAttribute('ondragleave', 'dragleaveSlider(event)');
            slider.setAttribute('ondragover', 'dragover(event)');
            slider.setAttribute('ondrop', 'dropOnSlider(event)');
            
            let sandbox = document.createElement("div");
            sandbox.id = "sandbox";
            sandbox.style.width = (popperWidth - sliderWidth) + 'px';
            sandbox.style.height = windowInnerHeight + 'px';
            popper.appendChild(slider);
            popper.appendChild(sandbox);
            let runner = document.getElementById("runner");
            runner.appendChild(popper);
        }

        function dragenterSlider(ev) {
            ev.preventDefault();

            var drag_target_data = ev.dataTransfer.getData("text/plain");
            if (drag_target_data.endsWith("_transparent_px")) { // transparent cards cannot be added to playground
                return;
            }
            // slider changes color when a card is dragged onto it
            ev.target.classList.add("active");
            ev.target.classList.remove("inactive");
        }

        function dragleaveSlider(ev) {
            ev.preventDefault();
            // slider changes color when a card is dragged onto it
            ev.target.classList.add("inactive");
            ev.target.classList.remove("active");
        }

        function dropOnSlider(ev) {
            ev.preventDefault();
            var draggedCardData = ev.dataTransfer.getData("text/plain");
            if (!draggedCardData.endsWith("_transparent_px")) { // transparent cards cannot be added to playground
                var draggedCardId = draggedCardData;
                var draggedCard = document.getElementById(draggedCardId);
                var src = draggedCard.src;
                drawImageOnSandboxStage(draggedCardId, src); // copy of the card added to the sandbox
            }
            ev.target.classList.add("inactive");
            ev.target.classList.remove("active");
        }

        function drawImageOnSandboxStage(i, src) {
            var layer = new Konva.Layer();
            var imageObj = new Image();
            imageObj.onload = function() {
                var wi = this.width;
                var he = this.height;
                var img = new Konva.Image({
                    image: imageObj,
                    x: 24 + 40 * i, // shift between cards to make it easier to find the cards that were added to sandbox
                    y: 60,
                    width: wi / ratio,
                    height: he / ratio,
                    draggable: true
                });
                img.on('click dragstart', function() {
                    layer.moveToTop(); // click to put card in the foreground
                    layer.draw();
                });
                img.on('dblclick', function() { // double click to remove card from sandbox
                    layer.destroy();
                });
                var transformer = new Konva.Transformer({
                    node: img,
                    centeredScaling: false,
                    rotationSnaps: [0, 90, 180, 270],
                    resizeEnabled: true, // to zoom on card details
                    enabledAnchors: ['top-left', 'top-right', 'bottom-left', 'bottom-right'] 
                });
                layer.add(transformer);
                layer.add(img);
                stage.add(layer);
            }
            imageObj.src = src;
        }
    </script>
</body>
</html>